Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_season.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_season.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_season.f90	(revision 257)
@@ -174,15 +174,8 @@
     ! residence time of green tissue (years)
     REAL(r_std), DIMENSION(npts,nvm)                            :: green_age
-
-! ds 04/03    Old formulation for herbivores
-!!$    ! weights
-!!$    REAL(r_std), DIMENSION(npts)                            :: weighttot
-!!$    ! natural long-term leaf NPP ( gC/m**2/year)
-!!$    REAL(r_std), DIMENSION(npts)                            :: nlflong_nat
-!!$    ! residence time of green tissue (years)
-!!$    REAL(r_std), DIMENSION(npts)                            :: green_age
-
     ! herbivore consumption (gC/m**2/day)
     REAL(r_std), DIMENSION(npts)                            :: consumption
+    ! fraction of each gridcell occupied by natural vegetation
+    REAL(r_std), DIMENSION(npts)                            :: fracnat
 
     ! =========================================================================
@@ -225,5 +218,5 @@
 
        ! 1.2.1.1 "monthly"
-!MM PAS PARALLELISE!!
+       !MM PAS PARALLELISE!!
        IF ( ABS( SUM( moiavail_month(:,2:nvm) ) ) .LT. min_stomate ) THEN
 
@@ -277,5 +270,5 @@
 
        ! 1.2.3 "monthly" soil temperatures
-!MM PAS PARALLELISE!!
+       !MM PAS PARALLELISE!!
        IF ( ABS( SUM( tsoil_month(:,:) ) ) .LT. min_stomate ) THEN
 
@@ -464,5 +457,5 @@
     !         detect a beginning of the growing season by declaring it dormant
     !
-!NVMODIF
+    !NVMODIF
     DO j = 2,nvm
        WHERE ( ( gpp_week(:,j) .LT. min_gpp_allowed ) .OR. & 
@@ -470,9 +463,9 @@
             ( ( when_growthinit(:,j) .GT. 2.*one_year ) .AND. &
             ( biomass(:,j,icarbres) .GT. biomass(:,j,ileaf)*4. ) ) )
-!       WHERE ( ( gpp_week(:,j) .EQ. zero ) .OR. & 
-!            ( gpp_week(:,j) .LT. gppfrac_dormance * maxgppweek_lastyear(:,j) ) .OR. &
-!            ( ( when_growthinit(:,j) .GT. 2.*one_year ) .AND. &
-!            ( biomass(:,j,icarbres) .GT. biomass(:,j,ileaf)*4. ) ) )
-          
+       !       WHERE ( ( gpp_week(:,j) .EQ. zero ) .OR. & 
+       !            ( gpp_week(:,j) .LT. gppfrac_dormance * maxgppweek_lastyear(:,j) ) .OR. &
+       !            ( ( when_growthinit(:,j) .GT. 2.*one_year ) .AND. &
+       !            ( biomass(:,j,icarbres) .GT. biomass(:,j,ileaf)*4. ) ) )
+       
           time_lowgpp(:,j) = time_lowgpp(:,j) + dt
           
@@ -816,12 +809,55 @@
     !
 
+    IF(control%ok_dgvm ) THEN
+
+       fracnat(:) = un
+       DO j = 2,nvm
+          IF ( .NOT. natural(j) ) THEN
+             fracnat(:) = fracnat(:) - veget_max(:,j)
+          ENDIF
+       ENDDO
+
+    ENDIF
+
     IF ( control%ok_stomate ) THEN
-
-       DO j = 2,nvm
-          WHERE ( biomass(:,j,ileaf) .GT. lm_thisyearmax(:,j) )
-             lm_thisyearmax(:,j) = biomass(:,j,ileaf)
-          ENDWHERE
-       ENDDO
-
+       IF(control%ok_dgvm ) THEN
+          DO j=2,nvm
+
+             IF ( natural(j) .AND. control%ok_dgvm ) THEN
+
+                WHERE ( fracnat(:) .GT. min_stomate .AND. biomass(:,j,ileaf).GT. lm_lastyearmax(:,j)*0.75 )
+                   maxfpc_lastyear(:,j) = ( maxfpc_lastyear(:,j) * ( one_year/leaflife_tab(j)- dt ) + &
+                        veget(:,j) / fracnat(:) * dt ) / (one_year/leaflife_tab(j))
+                ENDWHERE
+                maxfpc_thisyear(:,j) = maxfpc_lastyear(:,j) ! just to initialise value
+
+             ENDIF
+
+!NV : correct initialization
+!!$             WHERE(biomass(:,j,ileaf).GT. lm_lastyearmax(:,j)*0.75)
+!!$                lm_lastyearmax(:,j) = ( lm_lastyearmax(:,j) * ( one_year/leaflife_tab(j)- dt ) + &
+!!$                     biomass(:,j,ileaf) * dt ) / (one_year/leaflife_tab(j))
+!!$             ENDWHERE
+!!$             lm_thisyearmax(:,j)=lm_lastyearmax(:,j) ! just to initialise value
+             WHERE (lm_thisyearmax(:,j) .GT. min_stomate)
+                WHERE(biomass(:,j,ileaf).GT. lm_thisyearmax(:,j)*0.75)
+                   lm_thisyearmax(:,j) = ( lm_thisyearmax(:,j) * ( one_year/leaflife_tab(j)- dt ) + &
+                        biomass(:,j,ileaf) * dt ) / (one_year/leaflife_tab(j))
+                ENDWHERE
+             ELSEWHERE
+                lm_thisyearmax(:,j) =biomass(:,j,ileaf)
+             ENDWHERE
+
+          ENDDO
+
+       ELSE
+
+          DO j = 2,nvm
+             WHERE ( biomass(:,j,ileaf) .GT. lm_thisyearmax(:,j) )
+                lm_thisyearmax(:,j) = biomass(:,j,ileaf)
+             ENDWHERE
+          ENDDO
+
+       ENDIF
     ELSE
 
@@ -851,12 +887,12 @@
        ! 21.1 replace old values
        !
-!NVMODIF
-      maxmoiavail_lastyear(:,:) = (maxmoiavail_lastyear(:,:)*(tau_climatology-1)+ maxmoiavail_thisyear(:,:))/tau_climatology
-      minmoiavail_lastyear(:,:) = (minmoiavail_lastyear(:,:)*(tau_climatology-1)+ minmoiavail_thisyear(:,:))/tau_climatology
-      maxgppweek_lastyear(:,:) =( maxgppweek_lastyear(:,:)*(tau_climatology-1)+ maxgppweek_thisyear(:,:))/tau_climatology
-!       maxmoiavail_lastyear(:,:) = maxmoiavail_thisyear(:,:)
-!       minmoiavail_lastyear(:,:) = minmoiavail_thisyear(:,:)
-!       maxgppweek_lastyear(:,:) = maxgppweek_thisyear(:,:)
-
+       !NVMODIF
+       maxmoiavail_lastyear(:,:) = (maxmoiavail_lastyear(:,:)*(tau_climatology-1)+ maxmoiavail_thisyear(:,:))/tau_climatology
+       minmoiavail_lastyear(:,:) = (minmoiavail_lastyear(:,:)*(tau_climatology-1)+ minmoiavail_thisyear(:,:))/tau_climatology
+       maxgppweek_lastyear(:,:) =( maxgppweek_lastyear(:,:)*(tau_climatology-1)+ maxgppweek_thisyear(:,:))/tau_climatology
+       !       maxmoiavail_lastyear(:,:) = maxmoiavail_thisyear(:,:)
+       !       minmoiavail_lastyear(:,:) = minmoiavail_thisyear(:,:)
+       !       maxgppweek_lastyear(:,:) = maxgppweek_thisyear(:,:)
+       
        gdd0_lastyear(:) = gdd0_thisyear(:)
 
@@ -909,16 +945,16 @@
        !        fpc_crit.
 
-       ! calculate the sum of maxfpc_lastyear
-       sumfpc_nat(:) = zero
-       DO j = 2,nvm
-          sumfpc_nat(:) = sumfpc_nat(:) + maxfpc_lastyear(:,j)
-       ENDDO
-
-       ! scale so that the new sum is fpc_crit
-       DO j = 2,nvm 
-          WHERE ( sumfpc_nat(:) .GT. fpc_crit )
-             maxfpc_lastyear(:,j) = maxfpc_lastyear(:,j) * (fpc_crit/sumfpc_nat(:))
-          ENDWHERE
-       ENDDO
+!!$       ! calculate the sum of maxfpc_lastyear
+!!$       sumfpc_nat(:) = zero
+!!$       DO j = 2,nvm
+!!$          sumfpc_nat(:) = sumfpc_nat(:) + maxfpc_lastyear(:,j)
+!!$       ENDDO
+!!$
+!!$       ! scale so that the new sum is fpc_crit
+!!$       DO j = 2,nvm 
+!!$          WHERE ( sumfpc_nat(:) .GT. fpc_crit )
+!!$             maxfpc_lastyear(:,j) = maxfpc_lastyear(:,j) * (fpc_crit/sumfpc_nat(:))
+!!$          ENDWHERE
+!!$       ENDDO
 
     ENDIF  ! EndOfYear
@@ -941,56 +977,4 @@
 !!$ nlflong_nat, green_age are pft-dependants
 
-!!$    nlflong_nat(:) = zero
-!!$    weighttot(:) = zero
-!!$    green_age(:) = zero
-!!$    !
-!!$    DO j = 2,nvm
-!!$       !
-!!$       IF ( natural(j) ) THEN
-!!$          !
-!!$          weighttot(:) = weighttot(:) + lm_lastyearmax(:,j)
-!!$          nlflong_nat(:) = nlflong_nat(:) + npp_longterm(:,j) * leaf_frac_hvc
-!!$          !
-!!$          IF ( pheno_model(j) .EQ. 'none' ) THEN
-!!$             green_age(:) = green_age(:) + green_age_ever * lm_lastyearmax(:,j)
-!!$          ELSE
-!!$             green_age(:) = green_age(:) + green_age_dec * lm_lastyearmax(:,j)
-!!$          ENDIF
-!!$          !
-!!$       ENDIF
-!!$       !
-!!$    ENDDO
-!!$    !
-!!$    WHERE ( weighttot(:) .GT. zero )
-!!$       green_age(:) = green_age(:) / weighttot(:)
-!!$    ELSEWHERE
-!!$       green_age(:) = 1.
-!!$    ENDWHERE
-!!$
-!!$    !
-!!$    ! 22.2 McNaughton et al. give herbivore consumption as a function of annual leaf NPP.
-!!$    !      The annual leaf NPP can give us an idea about the edible biomass:
-!!$    !
-!!$
-!!$    DO j = 2,nvm
-!!$       !
-!!$       IF ( natural(j) ) THEN
-!!$          !
-!!$          WHERE ( nlflong_nat(:) .GT. zero )
-!!$             consumption(:) = hvc1 * nlflong_nat(:) ** hvc2
-!!$             herbivores(:,j) = one_year * green_age(:) * nlflong_nat(:) / consumption(:)
-!!$          ELSEWHERE
-!!$             herbivores(:,j) = 100000.
-!!$          ENDWHERE
-!!$          !
-!!$       ELSE
-!!$          !
-!!$          herbivores(:,j) = 100000.
-!!$          !
-!!$       ENDIF
-!!$       !
-!!$    ENDDO
-!!$    herbivores(:,ibare_sechiba) = zero
-
     nlflong_nat(:,:) = zero
     weighttot(:,:) = zero
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_soilcarbon.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_soilcarbon.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_soilcarbon.f90	(revision 257)
@@ -112,5 +112,4 @@
     frac_carb(:,islow,ipassive) = frac_carb_sp
 
-
     ! 1.1.1.3 from passive pool
 
@@ -118,5 +117,4 @@
     frac_carb(:,ipassive,iactive) = frac_carb_pa
     frac_carb(:,ipassive,islow) = frac_carb_ps
-
 
 
@@ -154,5 +152,5 @@
     !
 
-    resp_hetero_soil(:,:) = 0.0
+    resp_hetero_soil(:,:) = zero
 
     !
@@ -173,5 +171,5 @@
     !
 
-    frac_resp(:,:) = 1. - frac_carb(:,:,iactive) - frac_carb(:,:,islow) - &
+    frac_resp(:,:) = un - frac_carb(:,:,iactive) - frac_carb(:,:,islow) - &
          frac_carb(:,:,ipassive) 
 
@@ -191,9 +189,7 @@
              fluxtot(:,k) = dt/carbon_tau(k) * carbon(:,k,m) * &
                   control_moist(:,ibelow) * control_temp(:,ibelow)
-!!$   DS       ELSEIF ( PFT_name(m)=='          C3           agriculture' ) THEN
           ELSEIF ( (.NOT. natural(m)) .AND. (.NOT. is_c4(m)) ) THEN
              fluxtot(:,k) = dt/carbon_tau(k) * carbon(:,k,m) * &
                   control_moist(:,ibelow) * control_temp(:,ibelow) * flux_tot_coeff(1)
-!!$  DS         ELSEIF ( PFT_name(m)=='          C4           agriculture' ) THEN
           ELSEIF ( (.NOT. natural(m)) .AND. is_c4(m) ) THEN
              fluxtot(:,k) = dt/carbon_tau(k) * carbon(:,k,m) * &
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_turnover.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_turnover.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_turnover.f90	(revision 257)
@@ -196,5 +196,5 @@
                tl(:)*tl(:) * senescence_temp(j,3)
 
-          WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
+          WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. &
                ( leaf_meanage(:,j) .GT. min_leaf_age_for_senescence(j) ) .AND. &
                ( t2m_month(:) .LT. t_crit(:) ) .AND. ( t2m_week(:) .LT. t2m_month(:) ) )
@@ -215,5 +215,5 @@
                nosenescence_hum(j) )
 
-          WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
+          WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. &
                ( leaf_meanage(:,j) .GT. min_leaf_age_for_senescence(j) ) .AND. &
                ( moiavail_week(:,j) .LT. moiavail_crit(:) ) )
@@ -240,5 +240,5 @@
 
              ! critical temperature for senescence may depend on long term annual mean temperature
-             WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
+             WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. &
                   ( leaf_meanage(:,j) .GT. min_leaf_age_for_senescence(j) ) .AND. &
                   ( ( moiavail_week(:,j) .LT. moiavail_crit(:) ) .OR. &
@@ -319,8 +319,8 @@
              turnover(:,j,ifruit) = biomass(:,j,ifruit) * dt / turnover_time(:,j)
           ELSEWHERE
-             turnover(:,j,ileaf)=0.0
-             turnover(:,j,isapabove) =0.0
-             turnover(:,j,iroot) = 0.0
-             turnover(:,j,ifruit) =0.0
+             turnover(:,j,ileaf)= zero
+             turnover(:,j,isapabove) = zero
+             turnover(:,j,iroot) = zero
+             turnover(:,j,ifruit) = zero
           ENDWHERE
           biomass(:,j,ileaf) = biomass(:,j,ileaf) - turnover(:,j,ileaf)
@@ -364,5 +364,5 @@
 
           DO m = 1, nleafages
-             turnover_rate(:) =0 
+             turnover_rate(:) = zero
              WHERE ( leaf_age(:,j,m) .GT. leaf_age_crit(:,j)/2. )
 
@@ -454,5 +454,5 @@
              leaf_frac(:,j,m) = ( leaf_frac(:,j,m)*lm_old(:) + delta_lm(:,m) ) / biomass(:,j,ileaf)
           ELSEWHERE
-             leaf_frac(:,j,m) = 0.0
+             leaf_frac(:,j,m) = zero
           ENDWHERE
 
@@ -489,5 +489,5 @@
           ! check whether we shed the remaining leaves
 
-          WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. senescence(:,j) .AND. &
+          WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. senescence(:,j) .AND. &
                ( biomass(:,j,ileaf) .LT. (lai_initmin(j) / 2.)/sla(j) )             )
 
@@ -498,12 +498,12 @@
              turnover(:,j,ifruit) = turnover(:,j,ifruit) + biomass(:,j,ifruit)
 
-             biomass(:,j,ileaf) = 0.0
-             biomass(:,j,iroot) = 0.0
-             biomass(:,j,ifruit) = 0.0
+             biomass(:,j,ileaf) = zero
+             biomass(:,j,iroot) = zero
+             biomass(:,j,ifruit) = zero
 
 
 
              ! reset leaf age
-             leaf_meanage(:,j) = 0.0
+             leaf_meanage(:,j) = zero
 
           ENDWHERE
@@ -519,5 +519,5 @@
           ! Shed the remaining leaves if LAI very low.
 
-          WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. senescence(:,j) .AND. &
+          WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. senescence(:,j) .AND. &
                (  biomass(:,j,ileaf) .LT. (lai_initmin(j) / 2.)/sla(j) ))
 
@@ -529,13 +529,13 @@
              turnover(:,j,ifruit) = turnover(:,j,ifruit) + biomass(:,j,ifruit)
 
-             biomass(:,j,ileaf) = 0.0
-             biomass(:,j,isapabove) = 0.0
-             biomass(:,j,iroot) = 0.0
-             biomass(:,j,ifruit) = 0.0
+             biomass(:,j,ileaf) = zero
+             biomass(:,j,isapabove) = zero
+             biomass(:,j,iroot) = zero
+             biomass(:,j,ifruit) = zero
 
 
 
              ! reset leaf age
-             leaf_meanage(:,j) = 0.0
+             leaf_meanage(:,j) = zero
 
           ENDWHERE
@@ -551,6 +551,6 @@
           WHERE ( shed_rest(:) )
 
-             leaf_age(:,j,m) = 0.0
-             leaf_frac(:,j,m) = 0.0
+             leaf_age(:,j,m) = zero
+             leaf_frac(:,j,m) = zero
 
           ENDWHERE
@@ -679,5 +679,5 @@
              hw_new(:) = biomass(:,j,iheartabove) + biomass(:,j,iheartbelow)
 
-             WHERE ( hw_new(:) .GT. 0.0 )
+             WHERE ( hw_new(:) .GT. zero )
 
                 age(:,j) = age(:,j) * hw_old(:)/hw_new(:)
